#pragma once

#include <boost/asio.hpp>
#include <boost/thread/thread.hpp>

using boost::asio::ip::tcp;
using namespace std;

class Network
{
public:
	Network();
	~Network();

	bool connect( string address, int port);
	void listen(int port, void (*server_connection)(Network&), bool background = true);
	bool send_message(string message);
	void send_message(unsigned char *buffer, size_t n);
	string read_message();

	unsigned char *read_message(size_t n);
	void set_socket(tcp::socket *sock);
	void stop_listen();

private:
	void listen_helper(int port, void (*server_connection)(Network&));
	void server_connection_helper(tcp::socket *sock, void (*server_connection)(Network&));

	boost::asio::io_service	m_io_service;
	tcp::socket				*m_socket;
	tcp::acceptor			*m_acceptor;
};